SUBROUTINE eigensys(n,A,Val,Vec)
USE jm_constants

! Finds the eigenvectors and eigenvalues of the real symmetric matrix.

IMPLICIT none

INTEGER,       INTENT(IN)  :: n
REAL(KIND=dp), INTENT(IN)  :: a(n,n)
REAL(KIND=dp), INTENT(OUT) :: val(n), vec(n,n)
REAL(KIND=dp)              :: fwork(8*n)
INTEGER                    :: nerr, iwork(n)

CALL rsm(n, n, a, val, n, vec, fwork, iwork, nerr)

IF (nerr /= 0) PRINT*,'(eigensys) Warning: an unknown error occured.'

RETURN
END SUBROUTINE eigensys

!***********************************************************************