SUBROUTINE jm_header(unit)
USE jm_global, ONLY: estart, eend, estep, l, kappa, lambda, basis, scheme, &
    vol, pot_type, shift, nstart, nend, v0, a, b, r0, z, alpha, pass

! Writes the header of the output file.

IMPLICIT NONE

INTEGER, INTENT(in) :: unit
CHARACTER(LEN=8)    :: date
CHARACTER(LEN=10)   :: time
CHARACTER(LEN=5)   :: zone
INTEGER :: val(8)

!date_and_time(date, time)
CALL date_and_time(date,time,zone,val)


WRITE(unit,'(A33)') '; OUTPUT FROM THE JMATRIX PROGRAM'
WRITE(unit,'(A8,I4,A1,I2,A1,I2,A8,I2,A1,I2)')                       &
'; date: ',val(1),'.',val(2),'.',val(3),'  time: ',val(5),'.',val(6)
WRITE(unit,'(A1)') ';'
IF (pass==1) THEN
  WRITE(unit,'(A13,F22.16)')   '; energy   = ', estart
ELSE
  WRITE(unit,'(A13,F22.16)')   '; estart   = ', estart
  WRITE(unit,'(A13,F22.16)')   '; eend     = ', eend
  WRITE(unit,'(A13,F22.16)')   '; estep    = ', estep
ENDIF
WRITE(unit,'(A13,I5)')  '; l        = ', l
WRITE(unit,'(A13,I5)')  '; kappa    = ', kappa
WRITE(unit,'(A13,F22.16)')   '; lambda   = ', lambda
WRITE(unit,'(A13,A)')   '; basis    = ', basis
WRITE(unit,'(A13,A)')   '; scheme   = ', scheme
WRITE(unit,'(A13,A)')   '; v_light  = ', vol
WRITE(unit,'(A13,L1)')   '; shift    = ', shift
IF (pass==1) THEN
  WRITE(unit,'(A13,I5)')  '; nstart   = ', nstart
  WRITE(unit,'(A13,I5)')  '; nend     = ', nend
ELSE
  WRITE(unit,'(A13,I5)')  '; ntrunc   = ', nend
ENDIF
WRITE(unit,'(A13,A)')   '; pot_type = ', pot_type
SELECT CASE (pot_type)
CASE ('well')
  WRITE(unit,'(A13,F22.16)')   '; v0       = ', v0
  WRITE(unit,'(A13,F22.16)')   '; a        = ', a
  WRITE(unit,'(A13,F22.16)')   '; b        = ', b
CASE ('coulomb')
  WRITE(unit,'(A13,F22.16)')   '; r0       = ', r0
  WRITE(unit,'(A13,F22.16)')   '; z        = ', z
  WRITE(unit,'(A13,F22.16)')   '; alpha    = ', alpha
END SELECT

WRITE(unit,'(A1)') ';'

RETURN

END SUBROUTINE jm_header
