FUNCTION integral(fun,a,b)
USE jm_constants

! Numerical integration of the function fun in the bounds [a,b].

IMPLICIT none

REAL(KIND=dp), INTENT(in) :: a, b
REAL(KIND=dp), EXTERNAL   :: fun
REAL(KIND=dp)             :: integral
REAL(KIND=dp)             :: epsrel, err
REAL(KIND=dp)             :: work(0:8000)
INTEGER                   :: lenw

lenw   = 8000
epsrel = 1.d-8

CALL intdeini(lenw,1.0D-307,epsrel,work)
CALL intde(fun,a,b,work,integral,err)

!IF (err < 0) PRINT*,'integral: Warning - requested accuracy not achieved.'

RETURN
END FUNCTION integral

!***********************************************************************

FUNCTION integral_inf(fun,a)
USE jm_constants

! Numerical integration of the function fun in the bounds
! [-Inf,Inf], [a,Inf] lub [-Inf,a], depending on the value of <typ>.

IMPLICIT none

REAL(KIND=dp), INTENT(in) :: a
REAL(KIND=dp), EXTERNAL   :: fun
REAL(KIND=dp)             :: integral_inf
REAL(KIND=dp)             :: epsrel, err
REAL(KIND=dp)             :: work(8000)
INTEGER                   :: lenw

lenw   = 8000
epsrel = 1.d-8

CALL intdeiini(lenw,1.0D-307,epsrel,work)
CALL intdei(fun,a,work,integral_inf,err)

!IF (err < 0) PRINT*,'integral_inf: Warning - requested accuracy not achieved.'

RETURN
END FUNCTION integral_inf

!***********************************************************************