FUNCTION jm(i,j)
USE jm_constants
USE jm_global, ONLY : ntrunc, scheme, e, v_light, k

! Computes the elements of the J-matrix.

IMPLICIT none

INTEGER, INTENT(IN)        :: i, j
REAL(KIND=dp)              :: jm
REAL(KIND=dp)              :: psipsi, fifi


IF (scheme == 'relativistic') THEN
  
  IF (i+1 <= ntrunc .AND. j+1 <= ntrunc) THEN
    jm = -e * fifi(ntrunc-i-1, ntrunc-j-1)
  ELSE IF (i+1 <= ntrunc .AND. j+1 >  ntrunc) THEN
    jm = v_light * psipsi(ntrunc-i-1, j-ntrunc)
  ELSE IF (i+1 >  ntrunc .AND. j+1 >  ntrunc) THEN
    jm = -(e + two * v_light**2) * psipsi(i-ntrunc, j-ntrunc)
  ELSE IF (i+1 >  ntrunc .AND. j+1 <= ntrunc) THEN 
    jm = v_light * psipsi(ntrunc-j-1, i-ntrunc)
  ENDIF
  
ELSE
  
  jm = half * psipsi(i,j)  -  k**2 / two * fifi(i,j)
  
ENDIF

RETURN
END FUNCTION jm

!***********************************************************************
