FUNCTION t(n)
USE jm_constants
USE jm_global, ONLY: scheme, eps, v_light, k, e

! Numerical value of the tangent to the phase shift for the given <n>.

IMPLICIT none

INTEGER, INTENT(IN) :: n
REAL(KIND=dp)       :: t
REAL(KIND=dp)       :: s, c, g, jm
REAL(KIND=dp)       :: tmp, gn, jmn
CHARACTER (LEN=16)  :: tmp_scheme

gn = g(n-1,n-1)

IF (scheme == 'relativistic') THEN
  tmp_scheme = scheme            ! We have the non-relativistic elements Jm
  scheme = 'non-relativistic'    ! in formula for t - so we "cheat"
  jmn = jm(n,n-1)                ! the subroutine which computes them.
  scheme = tmp_scheme
ELSE
  jmn = jm(n,n-1)
ENDIF

IF (scheme == 'relativistic') THEN
  tmp = two * eps * v_light / k
ELSE
  tmp = one
ENDIF

t = - ( s(n-1) + tmp * gn * jmn * s(n) ) / ( c(n-1) + tmp * gn * jmn * c(n) )

RETURN
END FUNCTION t

!***********************************************************************