PROGRAM JMATRIX
USE jm_global, ONLY: pass1, pass2, loadparams, pot_type, fin, fout

! The main segment of the JMATRIX program.

  PRINT*
  WRITE(*,'(A)') 'Starting the JMATRIX program...'
  PRINT*
  WRITE(*,'(A)') 'Enter name of the input file  ( <cr> = jm.inp ).'
  READ (*,'(A)') fin
  IF (fin == '') fin = 'jm.inp'
  CALL loadparams(fin)                     ! Read the input data
  WRITE(*,'(A)') 'Load complete.'

  PRINT*
  WRITE(*,'(A)') 'The following output files will be created:'
  PRINT*,'<root>    - phase shifts as function of the basis size.'
  PRINT*,'<root>.en - phase shifts as function of energy of the projectile.'
  PRINT*,'saved.vn  - elements of the truncated potential.'
  WRITE(*,'(A)') 'Enter root name of the output files ( <cr> = jm.out ).'
  READ (*,'(A)') fout
  IF (fout == '') fout = 'jm.out'
  

  OPEN(2,file=fout,err=2)
  CALL pass1()     ! Look for the convergence with a fixed energy <estart> - 
  CLOSE(2)         ! calculate phase shifts for <ntrunc> = <nstart>... <nend>


  OPEN(3,file=trim(fout)//'.en',err=2)
  CALL pass2()     ! Collecting phase shifts for given energies 
  CLOSE(3)         ! from range [<estart>, <eend>] for <ntrunc> = <nend>


  PRINT*
  WRITE(*,'(A)') 'JMATRIX complete...'
  STOP

2 STOP '(JMATRIX) Error: cannot open the output file.'

END PROGRAM JMATRIX

!***********************************************************************
